#include "dumptrans.h"

/*
 * dumptrans.c
 *
 * program that dumps the contents of an account
 */

void main(int argc, char *argv[])
{
  int datum, porc, amount;
  char *pgDatum;
  char minibuff[513];

  pgDatum = malloc(11);

  if (argc < 3) {
    fprintf(stderr, "You must supply a date and a poadov cslo.\n");
    exit(0);
  }

  /* check validity of supplied date */
  datum = atoi(argv[1]);
  porc = atoi(argv[2]);
  if ((datum < 19700000) || (datum > 21000000)) {
    fprintf(stderr, "Zadejte datum ve tvaru YYYYMMDD.\n");
    exit(0);
  }
  if ((porc < 1) || (porc > 999)) {
    fprintf(stderr, "Zadan poadov slo je pravdpodobn patn.\n");
    exit(0);
  }

  initBackend();                /* initialize the backend connection */

  sprintf(minibuff, "SELECT desig FROM descs WHERE ent_date='%s' and por_cislo=%d;", pgConvertDate(pgDatum, datum), porc);
  runQuery(minibuff);
  if (numberReturned() == 0) {
    fprintf(stderr, "Nic nenalezeno.\n");
    exit_nicely();
  }
  printf("%d:%03d %-30s\n", datum, porc, getField("desig"));
  sprintf(minibuff, "DECLARE a1 CURSOR FOR SELECT ent_date, por_cislo, md_acct, md_anal, md_amt, d_acct, d_anal, d_amt FROM denik WHERE ent_date='%s' AND por_cislo=%d ORDER BY ent_date, por_cislo;", pgConvertDate(pgDatum, datum), porc);
  startTransaction();
  runQuery(minibuff);
  while (fetchNext("a1")) {
    if ((amount = atoi(getField("md_amt"))) > 0) {
      printf("%s %s %10d.%02d\n", getField("md_acct"), getField("md_anal"), (amount/100), (amount%100));
    } else 
      if ((amount = atoi(getField("d_amt"))) > 0) {
	printf("%s %s               %10d.%02d\n", getField("d_acct"), getField("md_anal"), (amount/100), (amount%100));
      } else {
	fprintf(stderr, "Corrupt database: either credit or debit side must = 0 in 'denik'");
	exit_nicely();
      }
  }

  endTransaction();
  
  exit_nicely();
}
      
