#include "fiscyear.h"

/*
 * fiscyear.c
 *
 * Program to query, initialize, or change the fiscal year
 *
 */

void main(int argc, char *argv[])
{
  int mode, noofrecs;
  int start_date, end_date;
  char *pgDatum;
  char miscbuff[81];

  pgDatum = malloc(11);

  if (argc < 3) {
    mode = FYQUERY;
  } else {
    mode = FYINIT;
    start_date = atoi(argv[1]);
    end_date = atoi(argv[2]);
    if ((start_date < 19700000) ||
        (end_date   < 19700000) ||
        (start_date > 20991231) ||
        (end_date  >  20991231) ||
        (start_date > end_date)) {
      fprintf(stderr, "Your starting and ending dates don't make sense.\n");
      exit(0);
    }
  }

   /* Initialize the backend */
   initBackend();

   /* start a transaction block */
   startTransaction();

   sprintf(miscbuff, "SELECT * FROM fiscyear;");
   runQuery(miscbuff);
   noofrecs = numberReturned();

   if (mode == FYQUERY) {
     if (noofrecs == 0) {
       printf("The fiscal year is not yet initialized!\n");
     } else {
       printf("The fiscal year is set to %d - %d.\n", NathanConvertDate(getField("startd")), NathanConvertDate(getField("endd")));
     }
   } else {
     if (noofrecs == 0) {
       sprintf(miscbuff, "INSERT INTO fiscyear VALUES ('%s', '%s');", pgConvertDate(pgDatum, start_date), pgConvertDate(pgDatum, end_date));
       runQuery(miscbuff);
       printf("Fiscal year initialized to %d - %d.\n", start_date, end_date);
     } else {
       sprintf(miscbuff, "UPDATE fiscyear SET startd='%s', endd='%s';", pgConvertDate(pgDatum, start_date), pgConvertDate(pgDatum, end_date));
       runQuery(miscbuff);
       printf("Fiscal year changed to %d - %d.\n", start_date, end_date);
     }
   }

   /* End the transaction */
   endTransaction();

   exit_nicely();
}
